package cz.cvut.fel.cs.ass.factoryMethod.product;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class Order {

	private List<OrderLine> orderList = new ArrayList<OrderLine>();

	public void addLine(Product product, int amount) {
		// aggregation
		for(OrderLine line : orderList) {
			if (line.getProduct() == product) { // left == on purpose!
				line.setAmount(line.getAmount()+amount);
				return;
			}
		}
		
		orderList.add(OrderLine.make(product, amount));
	}

	public BigDecimal getTotal() {
		BigDecimal total = BigDecimal.ZERO;
		for (OrderLine orderLine : orderList) {
			total = total.add(orderLine.getSubTotal());
		}
		return total;
	}

	public List<OrderLine> getOrderList() {
		return orderList;
	}
}
