package cz.cvut.fel.cs.ass.factoryMethod.store.impl;

import java.util.Arrays;
import java.util.List;

import cz.cvut.fel.cs.ass.factoryMethod.distributor.Distributor;
import cz.cvut.fel.cs.ass.factoryMethod.distributor.impl.CzechPost;
import cz.cvut.fel.cs.ass.factoryMethod.distributor.impl.DPD;
import cz.cvut.fel.cs.ass.factoryMethod.product.Order;
import cz.cvut.fel.cs.ass.factoryMethod.product.OrderLine;
import cz.cvut.fel.cs.ass.factoryMethod.product.Product;
import cz.cvut.fel.cs.ass.factoryMethod.store.Store;

public class Mall extends Store {

	private List<Distributor> distributorList = null;

	public Mall() {
		Distributor[] distributors = { new CzechPost(), new DPD() };
		distributorList = Arrays.asList(distributors);
	}

	public Mall(List<Distributor> distributorList) {
		this.distributorList = distributorList;
	}

	@Override
	public List<Distributor> getDistributorList() {
		return distributorList;
	}

	@Override
	protected void hookProcess(Order order) {
		System.out.println(Mall.class.getSimpleName() + " is happy for your order");
		for (OrderLine line : order.getOrderList()) {
			Product product = line.getProduct();
			System.out.println("+ " + product.getName() + " " + line.getAmount() + "x " + product.getPrice());

		}
		System.out.println("Total: " + order.getTotal());

	}

}
