package cz.cvut.fel.cs.ass.factoryMethod.test;

import java.math.BigDecimal;

import org.junit.Before;
import org.junit.Test;

import cz.cvut.fel.cs.ass.factoryMethod.distributor.Distributor;
import cz.cvut.fel.cs.ass.factoryMethod.product.Order;
import cz.cvut.fel.cs.ass.factoryMethod.product.Product;
import cz.cvut.fel.cs.ass.factoryMethod.product.impl.HeurecaProduct;
import cz.cvut.fel.cs.ass.factoryMethod.store.Store;
import cz.cvut.fel.cs.ass.factoryMethod.store.impl.Heureka;


public class UserTest {

	private Order order;
	private Store store;
	private Product soap;
	private Product soap2;
	private Product tabaco;
	private Product book;
	private Product lego;
	
	@Before 
	public void setUp() { 
		// pick store
		//store = new Mall();
		store = new Heureka();

		// pick product type
		// what if heureka product?
		soap = Product.make("Soap").init("Nice protocol", new BigDecimal(30)); 
		soap2 = Product.make("Soap").init("Nice protocol", new BigDecimal(30)); 
		tabaco = Product.make("Tabaco").init("Dont smoke", new BigDecimal(20));
		book = Product.make("Book").init("Read me", new BigDecimal(25));
		lego = HeurecaProduct.make("Lego").init("Play me", new BigDecimal(35), 1.0);
		
    }

	@Test
	public void test() throws Exception {
		// make an order
		order = new Order();
		order.addLine(soap, 2); // TODO change to fluentInterface
		order.addLine(soap2, 1); 
		order.addLine(tabaco, 2);
		order.addLine(lego, 1);
		order.addLine(book, 1);
		
		// try to process
		try {
			store.process(order);
		} catch (Exception e) {
			System.out.println("ERR: "+e.getMessage());
		}
		
		// <pick by rank>
		int index = 0;
		double rank = 0;
		for(int i = 0; i < store.getDistributorList().size(); i++) {
			Distributor distributor = store.getDistributorList().get(i);
			if(distributor.getRank() > rank) {
				index = i;
				rank = distributor.getRank();
			}
			System.out.println("* "+distributor.getClass().getSimpleName());
		}
		store.selectDistributor(index);
		// </pick by rank>

		
		// process
		store.process(order);

	}

}
