package cz.cvut.fel.cs.ass.singleton.test.hint;

import java.io.WriteAbortedException;
import java.util.Set;

import cz.cvut.fel.cs.ass.singleton.FileSystem;
import cz.cvut.fel.cs.ass.singleton.Printer;
import cz.cvut.fel.cs.ass.singleton.impl.LoggerImpl;
import cz.cvut.fel.cs.ass.singleton.impl.PrinterImpl;
import cz.cvut.fel.cs.ass.singleton.impl.SafeFileSystem;

public class User_1 implements Runnable {
	/*HELP*/
	private static FileSystem fs = new SafeFileSystem();
	private static Printer p = new PrinterImpl(fs);

	private String name;
	private Set<User_1> finishSet;

	public User_1(String name, Set<User_1> finishSet) {
		this.name = name;
		this.finishSet = finishSet;
	}

	@Override
	public void run() {
		// all try to use the same file 
		String fileName = "book.txt";
		String content = name + ".. content";

		try {
			// write content
			fs.write(fileName, content);
			// put fileName to print its content
			p.enqueueFileName(fileName);
			// print one
			p.print();
			// happy finished
			finishSet.add(this);
		} catch (WriteAbortedException e) {
			new LoggerImpl().log("Error writing a file, " + e.getMessage());
		} catch (Exception e) {
			new LoggerImpl().log("Error printing, " + e.getMessage());
		}

	}

}

