package cz.cvut.fel.cs.ass.singleton.test.hint;

import java.io.WriteAbortedException;
import java.util.Set;

import cz.cvut.fel.cs.ass.singleton.FileSystem;
import cz.cvut.fel.cs.ass.singleton.Printer;
import cz.cvut.fel.cs.ass.singleton.impl.LoggerImpl;
import cz.cvut.fel.cs.ass.singleton.impl.PrinterImpl;
import cz.cvut.fel.cs.ass.singleton.impl.SafeFileSystem;

public class User_3 implements Runnable {
	private static FileSystem fs = new SafeFileSystem();
	private static Printer p = new PrinterImpl(fs);

	private String name;
	private Set<User_3> finishSet;

	public User_3(String name, Set<User_3> finishSet) {
		this.name = name;
		this.finishSet = finishSet;
	}

	@Override
	public void run() {
		// all try to use the same file 
		String fileName = "book.txt";
		String content = name + ".. content";

		try {
			boolean written = false;
			
			while (!written) {
				try {
					// wait until name collision is removed
					while (fs.contains(fileName)) {
						Thread.sleep(1000);
					}
					// write content
					fs.write(fileName, content);
					written = true;
				} catch (WriteAbortedException e) {
					new LoggerImpl().log("Warning attept to write a file, " + e.getMessage());
				}
			}
			// put fileName to print its content
			p.enqueueFileName(fileName);
			// print one
			p.print();
			// happy finished
			finishSet.add(this);
		} catch (WriteAbortedException e) {
			new LoggerImpl().log("Error writing a file, " + e.getMessage());
		} catch (Exception e) {
			new LoggerImpl().log("Error printing, " + e.getMessage());
		}

	}

}
